.zink-common-rules:
  rules:
    - !reference [.gl-rules, rules]
    - changes:
      - src/gallium/drivers/zink/**/*
      when: on_success

.zink-common-manual-rules:
  retry: !reference [.scheduled_pipeline-rules, retry]
  rules:
    - !reference [.gl-manual-rules, rules]
    - changes:
      - src/gallium/drivers/zink/**/*
      when: manual

.zink-lvp-rules:
  stage: layered-backends
  rules:
    - !reference [.lavapipe-rules, rules]
    - !reference [.zink-common-rules, rules]

.zink-anv-rules:
  stage: layered-backends
  rules:
    - !reference [.anv-rules, rules]
    - !reference [.zink-common-rules, rules]

.zink-anv-manual-rules:
  stage: layered-backends
  retry: !reference [.scheduled_pipeline-rules, retry]
  rules:
    - !reference [.anv-manual-rules, rules]
    - !reference [.zink-common-manual-rules, rules]

.zink-anv-rules-restricted:
  stage: layered-backends
  rules:
    - !reference [.restricted-rules, rules]
    - !reference [.anv-rules, rules]
    - !reference [.zink-common-rules, rules]

.zink-turnip-rules:
  stage: layered-backends
  rules:
    - !reference [.turnip-rules, rules]
    - !reference [.zink-common-rules, rules]

.zink-turnip-manual-rules:
  stage: layered-backends
  retry: !reference [.scheduled_pipeline-rules, retry]
  rules:
    - !reference [.turnip-manual-rules, rules]
    - !reference [.zink-common-manual-rules, rules]

.zink-radv-rules:
  stage: layered-backends
  rules:
    - !reference [.radv-valve-rules, rules]
    - !reference [.zink-common-rules, rules]

.zink-radv-manual-rules:
  stage: layered-backends
  retry: !reference [.scheduled_pipeline-rules, retry]
  rules:
    - !reference [.radv-valve-manual-rules, rules]
    - !reference [.zink-common-manual-rules, rules]
    - changes:
      - .gitlab-ci/container/build-piglit.sh
      when: manual


.zink-test:
  timeout: 30m
  variables:
    MESA_LOADER_DRIVER_OVERRIDE: "zink"
    FLAKES_CHANNEL: "#zink-ci"

.zink-trace-test:
  extends:
    - .zink-test
  variables:
    # The libX11 in the debian we use doesn't XInitThreads() by default (need
    # 1.8.1 for that), and eglretrace's waffle GLX path doesn't call it either,
    # which ends up causing trouble with kopper's X usage.  Use gbm for our
    # trace replay, instead.
    # https://gitlab.freedesktop.org/mesa/mesa/-/issues/6753
    HWCI_START_XORG: ""
    WAFFLE_PLATFORM: gbm
    PIGLIT_PLATFORM: gbm

.zink-lvp-test:
  extends:
    - .zink-lvp-rules
    - .zink-test
  variables:
    LIBGL_ALWAYS_SOFTWARE: "true"
    LVP_POISON_MEMORY: "1"
    GPU_VERSION: zink-lvp
    # Fix non-conformant llvmpipe filter defaults
    GALLIVM_PERF: "no_quad_lod"

zink-lvp:
  extends:
    - .test-gl
    - .deqp-test
    - .zink-lvp-test
  variables:
    DEQP_SUITE: zink-lvp
    DEQP_FRACTION: 4
    PIGLIT_NO_WINDOW: 1
    # Enable validation (except for on piglit, see deqp-zink-lvp.toml), logging
    # to stdout and aborting on unknown failures.
    ZINK_DEBUG: validation
    XVFB_SCRIPT: "GALLIUM_DRIVER=zink VK_DRIVER=lvp install/deqp-runner.sh"
  script: |
    xvfb-run --server-args='-noreset' bash -c ". $SCRIPTS_DIR/setup-test-env.sh && ${XVFB_SCRIPT}"

.zink-anv-test:
  extends:
    - .anv-tgl-test
    - .zink-anv-rules
    - .zink-test
  variables:
    VK_DRIVER: intel
    GPU_VERSION: zink-anv-tgl

zink-anv-tgl:
  extends:
    - .zink-anv-test
  timeout: 1h
  variables:
    DEQP_SUITE: zink-anv-tgl
    PIGLIT_NO_WINDOW: 1
    HWCI_START_XORG: 1
    # We use gbm because X can die:
    # MESA: error: ZINK: vkQueueSubmit failed (VK_ERROR_DEVICE_LOST)
    # Xorg: ../src/gallium/drivers/zink/zink_batch.c:599: zink_end_batch: Assertion `!ctx->batch_states' failed.
    PIGLIT_PLATFORM: gbm

# Manual full run when you want to double-check the full status.
zink-anv-tgl-full:
  extends:
    - zink-anv-tgl
    - .zink-anv-manual-rules
  variables:
    DEQP_SUITE: zink-anv-tgl-full
    JOB_TIMEOUT: 90
    HWCI_START_WESTON: 1
  timeout: 1h 30m
  parallel: 3

zink-anv-tgl-traces:
  extends:
    - .lava-piglit-traces:x86_64
    - .zink-anv-test
    - .zink-trace-test
    # Add .lava-traces-base again to override .zink-anv-test setting the
    # HWCI_TEST_SCRIPT, but .lava-piglit-traces having to come first to get
    # dependencies right.
    - .lava-traces-base
  variables:
    MESA_LOADER_DRIVER_OVERRIDE: zink
    PIGLIT_REPLAY_DESCRIPTION_FILE: "/install/traces-zink.yml"

zink-anv-tgl-traces-restricted:
  extends:
    - zink-anv-tgl-traces
    - .zink-anv-rules-restricted
  variables:
    PIGLIT_REPLAY_DESCRIPTION_FILE: "/install/traces-zink-restricted.yml"
    PIGLIT_REPLAY_EXTRA_ARGS: --keep-image --db-path ${CI_PROJECT_DIR}/replayer-db/ --minio_bucket=mesa-tracie-private --jwt-file=${CI_JOB_JWT_FILE}
  allow_failure: true

zink-tu-a618:
  extends:
    - .lava-test-deqp:arm64
    - .a618-test
    - .zink-turnip-rules
    - .zink-test
  parallel: 3
  variables:
    DEQP_SUITE: zink-freedreno-a618
    HWCI_START_XORG: 1
    GPU_VERSION: zink-freedreno-a618
    JOB_TIMEOUT: 120
    VK_DRIVER: freedreno
    DEVICE_TYPE: sc7180-trogdor-lazor-limozeen
    DTB: sc7180-trogdor-lazor-limozeen-nots-r5
    RUNNER_TAG: mesa-ci-x86-64-lava-sc7180-trogdor-lazor-limozeen

zink-tu-a618-traces:
  extends:
    - a618-traces
    - .zink-turnip-rules
    - .zink-trace-test
  parallel: null
  variables:
    PIGLIT_REPLAY_DEVICE_NAME: "zink-a618"

zink-tu-a618-traces-performance:
  extends:
    - zink-tu-a618-traces
    - .zink-turnip-manual-rules
    - .piglit-performance:arm64
  rules:
    - !reference [.piglit-performance:arm64, rules]
    - !reference [.zink-turnip-manual-rules, rules]
  variables:
    # Always use the same device
    # a618 tag starts with cbg-1 (not cbg-0) for some reason
    LAVA_TAGS: "cbg-1"
  needs:
    - !reference [zink-tu-a618-traces, needs]
    - !reference [.piglit-performance:arm64, needs]

.zink-freedreno-a630-traces:
  extends:
    - a630-traces
    - .zink-turnip-rules
    - .zink-trace-test
  variables:
    PIGLIT_REPLAY_DEVICE_NAME: "zink-a630"

############### Combined testing (GL, GLES, Piglit) on RADV
.radv-zink-test-valve:
  timeout: 30m
  extends:
    - .zink-test
    - .test-radv
    - .b2c-test-gl
  variables:
    PIGLIT_PROFILES: all
    PIGLIT_PLATFORM: gbm
    HWCI_TEST_SCRIPT: ./install/valve/gl_combined_testing.sh
    B2C_JOB_SUCCESS_REGEX: 'Execution is over, pipeline status: 0'
    B2C_TIMEOUT_OVERALL_MINUTES: 20

    # Disable reporting, since DUTs don't have internet access
    FLAKES_CHANNEL: ""

zink-radv-navi10-valve:
  extends:
    - .radv-zink-test-valve
    - .navi10-test-valve
    - .zink-radv-manual-rules
  variables:
    GPU_VERSION: zink-radv-navi10

zink-radv-vangogh-valve:
  parallel: 3
  extends:
    - .radv-zink-test-valve
    - .vangogh-test-valve
    - .zink-radv-rules
  variables:
    GPU_VERSION: zink-radv-vangogh
  # Override the list of tags to drop `priority:low`
  tags:
    - amdgpu:codename:VANGOGH
